$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$! Make Library files of SHADOW.
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ say :== write sys$output
$
$ say " "
$ say "# Building the Library Modules of SHADOW/VMS #"
$ say " "
$
$!
$! Define the symbols necessary for compilation.
$!
$
$! set on
$! on error then goto CLEANUP
$! on control_c then goto CLEANUP
$! on control_y then goto CLEANUP
$
$ on error then continue
$ on warning then continue
$ on severe then continue
$
$
$!
$! Define the compilation flags. These flags are actually reset in
$! COMPILE.COM, so watch out.
$!
$
$ defines 	:=
$ ccompile 	:= cc'defines'/undefine=(ANSI_LIB)/debug/nooptimize
$ fcompile 	:= fortran'defines'/debug/nooptimize
$ compile	:= @[-]compile.com
$
$!
$! The libraries that are created here, and that are used in linking.
$!
$
$!libshadow	= "[-.lib]libshadow"
$ libname 	= "libshadow.olb"
$
$!
$! Go thru all subdirectories (if any) first and make those.
$!
$
$!
$! Compile all the source files.
$!
$
$!
$! create the local library first if it doesn't exist yet.
$!
$
$ if f$search(libname) .eqs. "" 
$ then 
$	say "Creating library ''libname'"
$	library/create 'libname'
$ endif
$ say " "
$
$ compile aline.for
$ compile clscreen.for 
$ compile cubspl.for
$ compile cputim.for
$ compile dbcevl.for
$ compile despace.for
$ compile fileinfo.for
$ compile fname.for
$ compile fpoly.for
$ compile frot.for
$ compile gnormal.for
$ compile ibcccu.for
$ compile iblank.for
$ compile icsccu.for
$ compile intspl.for
$ compile irint.for
$ compile istl.for
$ compile iyes.for
$ compile leave.for
$ compile lyesno.for
$ compile ltrim.for
$ compile mdnris.for
$ compile merfi.for
$ compile message.for
$ compile messages.for
$ compile mfp.for
$ compile myran.for
$ compile normal.for
$ compile piecespl.for
$ compile poly.for
$ compile quartic.for
$ compile rbeam.for
$ compile rbeam18.for
$ compile readaxis.for
$ compile rnumber.for
$ compile rotate.for
$ compile rotvector.for
$ compile rstring.for
$ compile rwname.for
$ compile uertst.for
$ compile uspkd.for
$ compile vector.for
$ compile writeoff.for
$ compile zbrent.for
$ compile zrpoly.for
$ compile fabnama.mar
$ compile ifileinfo.mar
$ compile isearch.mar
$
$ say " "
$ say "Adding *.obj to library ''libname'"
$ say " "
$ library/replace 'libname' 	-
	aline,-
	clscreen,-
	cubspl,-
	cputim,-
	dbcevl,-
	despace,-
	fileinfo,-
	fname,-
	fpoly,-
	frot,-
	gnormal,-
	ibcccu,-
	iblank,-
	icsccu,-
	intspl,-
	irint,-
	istl,-
	iyes,-
	leave,-
	lyesno,-
	ltrim,-
	mdnris,-
	merfi,-
	message,-
	messages,-
	mfp,-
	myran,-
	normal,-
	piecespl,-
	poly,-
	quartic,-
	rbeam,-
	rbeam18,-
	readaxis,-
	rnumber,-
	rotate,-
	rotvector,-
	rstring,-
	rwname,-
	uertst,-
	uspkd,-
	vector,-
	writeoff,-
	zbrent,-
	zrpoly,-
	fabnama,-
	ifileinfo,-
	isearch
$
$!
$! Make the final programs (if any) in this directory.
$!
$
$
$ CLEANUP:
$ say " "
$ say "# Done Making the Library Modules of SHADOW/VMS #"
$ say " "
$
$ EXIT
